unit UEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ValEdit, StdCtrls, ComCtrls, Menus, CheckLst;

type
  TEdit = class(TForm)
    Button1: TButton;
    ListView1: TListView;
    Label1: TLabel;
    Label2: TLabel;
    ListView2: TListView;
    Label3: TLabel;
    ListView3: TListView;
    Label4: TLabel;
    PopupMenu1: TPopupMenu;
    Pidatmetodu1: TMenuItem;
    Smazatmetodu1: TMenuItem;
    PopupMenu2: TPopupMenu;
    Pidatkrok1: TMenuItem;
    Odebratkrok1: TMenuItem;
    ListView4: TListView;
    Label5: TLabel;
    Label6: TLabel;
    ListView5: TListView;
    ListView6: TListView;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure Pidatmetodu1Click(Sender: TObject);
    procedure ListView1Edited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure Pidatkrok1Click(Sender: TObject);
    procedure ListView3SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ListView2SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ListView5Edited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure ListView6Edited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure Odebratkrok1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ListView2Redraw;
    procedure ListView1Redraw;
    { Public declarations }
  end;

var
  Edit: TEdit;

implementation

uses UMainWindow, DateUtils, Math;

{$R *.dfm}

procedure TEdit.Button1Click(Sender: TObject);
begin
  MainWindow.ListView2Reload;
  MainWindow.SaveToFile;
  Close;
end;

procedure TEdit.FormShow(Sender: TObject);
var
  I: Integer;
  NewItem: TListItem;
begin
  ListView1Redraw;
  
  // Vpis seznamu monch krok
  with ListView3.Items, MainWindow do begin
    BeginUpdate;
    Clear;
    for I:= 0 to High(AllStepsList) do begin
      NewItem:= Add;
      NewItem.Caption:= AllStepsList[I].Name;
    end;
    EndUpdate;
  end;
end;

procedure TEdit.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  ListView2Redraw;
end;

procedure TEdit.Pidatmetodu1Click(Sender: TObject);
begin
  with MainWindow do begin
    SetLength(Methods,Length(Methods)+1);
    Methods[High(Methods)]:= TMetoda.Create;
  end;
  ListView1Redraw;
  ListView1.Items.Item[ListView1.Items.Count-1].Selected:= True;
end;

procedure TEdit.ListView1Edited(Sender: TObject; Item: TListItem;
  var S: String);
begin
  MainWindow.Methods[Item.Index].Nazev:= S;
end;

procedure TEdit.Pidatkrok1Click(Sender: TObject);
var
  I: Integer;
  Index: Integer;
begin
  if Assigned(ListView1.Selected) and Assigned(ListView3.Selected) then with MainWindow.Methods[ListView1.ItemIndex] do begin
    if Assigned(ListView2.Selected) then Index:= ListView2.Selected.Index+1 else Index:= Length(Steps);
    SetLength(Steps,Length(Steps)+1);
    for I:= High(Steps) downto Index+1 do Steps[I]:= Steps[I-1];
    Steps[Index]:= TStep.Create;
    with Steps[Index] do begin
      StepType:= ListView3.ItemIndex;
      SetLength(Inputs.Pins, Length(MainWindow.AllStepsList[ListView3.ItemIndex].InputsType));
      SetLength(Outputs.Pins, Length(MainWindow.AllStepsList[ListView3.ItemIndex].OutputsType));
      SetLength(Properties, Length(MainWindow.AllStepsList[ListView3.ItemIndex].PropertiesType));
      for I:= 0 to High(Properties) do with Properties[I] do begin
        Typ:= MainWindow.AllStepsList[ListView3.ItemIndex].PropertiesType[I].PinType;
        case Typ of
          tpInteger: Data:= TIntegerType.Create;
          tpReal: Data:= TRealType.Create;
          tpBoolean: Data:= TBooleanType.Create;
          tpTColor: Data:= TColorType.Create;
        end;
      end;
    end;
    ListView2Redraw;
  end;
end;

procedure TEdit.ListView2Redraw;
var
  I, J: Integer;
  NewItem: TListItem;
  PomocnyText: string;
  Vybrany: Integer;
begin
//  ShowMessage(IntToStr(ListView1.ItemIndex));
  // Vpis seznamu monch krok
  if Assigned(ListView1.Selected) then
  with ListView2.Items, MainWindow.Methods[ListView1.ItemIndex] do begin
    if Assigned(ListView2.Selected) then Vybrany:= ListView2.Selected.Index
    else Vybrany:= High(Integer);
    BeginUpdate;
    Clear;
    for I:= 0 to High(Steps) do with Steps[I] do begin
      NewItem:= Add;
      for J:= 0 to High(Inputs.Pins) do NewItem.Caption:= NewItem.Caption + IntToStr(Inputs.Pins[J])+' ';
      with NewItem.SubItems do begin
        Add(MainWindow.AllStepsList[StepType].Name);
        PomocnyText:= '';
        for J:= 0 to High(Outputs.Pins) do PomocnyText:= PomocnyText + IntToStr(Outputs.Pins[J])+' ';
        Add(PomocnyText);
      end;
    end;
    EndUpdate;
    // ShowMessage(IntToStr(Vybrany));
    if ListView2.Items.Count>Vybrany then
      if Assigned(ListView2.Items.Item[Vybrany]) then ListView2.Items.Item[Vybrany].Selected:= True;
  end;
end;

procedure TEdit.ListView1Redraw;
var
  I: Integer;
  NewItem: TListItem;
  SelectedIndex: Integer;
begin
  // Vpis seznamu metod
  with ListView1.Items, MainWindow do begin
    BeginUpdate;
    SelectedIndex:= ListView1.ItemIndex;
    Clear;
    for I:= 0 to High(Methods) do begin
      NewItem:= Add;
      NewItem.Caption:= Methods[I].Nazev;
    end;
    if (SelectedIndex>=0) and (SelectedIndex<Count) then ListView1.ItemIndex:= SelectedIndex;
    EndUpdate;
  end;
  ListView2Redraw;
end;

procedure TEdit.ListView3SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
  I: Integer;
  NewItem: TListItem;
begin
  if Assigned(ListView3.Selected) then with ListView4, Items do begin
    BeginUpdate;
    Clear;
    with MainWindow.AllStepsList[ListView3.Selected.Index] do
    for I:= 0 to High(PropertiesType) do begin
      NewItem:= Add;
      NewItem.Caption:= PropertiesType[I].Text;
    end;
    EndUpdate;
  end;
end;

procedure TEdit.ListView2SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
  I: Integer;
  NewItem: TListItem;
begin
  if Assigned(ListView1.Selected) and Assigned(ListView2.Selected) then
  with MainWindow.Methods[ListView1.Selected.Index].Steps[ListView2.Selected.Index] do begin
    with ListView5, Items do begin
      BeginUpdate;
      Clear;
      for I:= 0 to High(Inputs.Pins) do begin
        NewItem:= Add;
        NewItem.Caption:= IntToStr(Inputs.Pins[I]);
      end;
      EndUpdate;
    end;
    with ListView6, Items do begin
      BeginUpdate;
      Clear;
      for I:= 0 to High(Outputs.Pins) do begin
        NewItem:= Add;
        NewItem.Caption:= IntToStr(Outputs.Pins[I]);
      end;
      EndUpdate;
    end;
  end;
end;

procedure TEdit.ListView5Edited(Sender: TObject; Item: TListItem;
  var S: String);
begin
  if Assigned(ListView1.Selected) and Assigned(ListView2.Selected) then
  with MainWindow.Methods[ListView1.Selected.Index].Steps[ListView2.Selected.Index] do begin
    if not TryStrToInt(S,Inputs.Pins[ListView5.Selected.Index]) then S:= ListView5.Selected.Caption;
    ListView2Redraw;
  end;
end;

procedure TEdit.ListView6Edited(Sender: TObject; Item: TListItem;
  var S: String);
begin
  if Assigned(ListView1.Selected) and Assigned(ListView2.Selected) then
  with MainWindow.Methods[ListView1.Selected.Index].Steps[ListView2.Selected.Index] do begin
    if not TryStrToInt(S,Outputs.Pins[ListView6.Selected.Index]) then S:= ListView6.Selected.Caption;
    ListView2Redraw;
  end;
end;

procedure TEdit.Odebratkrok1Click(Sender: TObject);
var
  I: Integer;
begin
  if Assigned(ListView1.Selected) and Assigned(ListView2.Selected) then with MainWindow.Methods[ListView1.ItemIndex] do begin
    Steps[ListView2.Selected.Index].Free;
    for I:= ListView2.Selected.Index+1 to High(Steps) do Steps[I-1]:= Steps[I];
    SetLength(Steps,Length(Steps)-1);
    ListView2Redraw;
  end;
end;

end.
