unit UExceptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Sockets, ExtCtrls, Registry;

type
  TOdeslani = class(TThread)
     Bezi: Boolean;
     procedure Execute; override;
  end;

  TRadekInfoVyjimky = record
    Popis: string;
    Text: string;
  end;

  TOsetreniVyjimek = class(TForm)
    Label1: TLabel;
    TcpClient1: TTcpClient;
    Button1: TButton;
    Edit1: TEdit;
    Label2: TLabel;
    Button2: TButton;
    Memo1: TMemo;
    Image1: TImage;
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    Odeslani: TOdeslani;
    Data: array of TRadekInfoVyjimky;
    Vyska: Integer;
    procedure Odeslat;
  public
    Stav: string;       // Obsah loklnch promnnch
    NazevAplikace: string;   // Nzev aplikace
    procedure Obsluha(Sender : TObject; E : Exception );
    procedure Pridat(NovyPopis, NovyText: string);
  end;

var
  OsetreniVyjimek: TOsetreniVyjimek;

implementation

{$R *.dfm}

{ TOsetreniVyjimek }

function ReturnAddr(Index: Integer): Pointer;
asm
  MOV     EAX,[EBP+Index*4]
end;

procedure TOsetreniVyjimek.Obsluha(Sender: TObject; E: Exception);
const
  NazevSouboru = 'Error.txt';
var
  ExtRec: PExceptionRecord;
  Log: string;
  Soubor: TextFile;
  I: Integer;
begin
  Pridat('as',DateTimeToStr(Now));
  Pridat('Text chyby',E.Message);
  Pridat('Tda vyjmky',E.ClassName);
  Pridat('Adresa',Format('%p',[ReturnAddr(6)]));
  Pridat('Aplikace',NazevAplikace);
  Pridat('Stavov informace',Stav);

  ShowModal;    // Uka dialog

  if Edit1.Text<>'' then Pridat('Koment uivatele',Edit1.Text);

  // Uloit chybu do souboru
  AssignFile(Soubor,NazevSouboru);
  try
    if FileExists(NazevSouboru) then Append(Soubor) else Rewrite(Soubor);
    WriteLn(Soubor);
    for I:= 0 to High(Data) do WriteLn(Soubor,Data[I].Popis+': '+Data[I].Text);
  finally
    CloseFile(Soubor);
  end;
  Odeslani.Execute;
end;

procedure TOsetreniVyjimek.Pridat(NovyPopis, NovyText: string);
begin
  SetLength(Data,Length(Data)+1);
  with Data[High(Data)] do begin
    Popis:= NovyPopis;
    Text:= NovyText;
  end;
end;

procedure TOsetreniVyjimek.Odeslat;
var
  I, II: Integer;
  Hlaseni: string;
  Buf: array[0..10000] of Char;
  Pocet: Integer;
  Radek: string;
  Proxy: Boolean;
  ProxyServer: string;
  ProxyPort: string;
  Host, HostHTTP: string;
const
  Mailer = '195.250.155.29';
//  Mailer = '127.0.0.1';
begin
//  Hlaseni:= '&data=';
  with TRegistry.Create do try
    RootKey:= HKEY_CURRENT_USER;
    OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings', False);
    Proxy := ReadBool('ProxyEnable');
    ProxyServer := ReadString('ProxyServer');
  finally
    Free;
  end;
  Hlaseni:= '&TO=robie@centrum.cz&SUBJECT=Chyba aplikace '+NazevAplikace+'&From=robie@centrum.cz&Dopis='+#13#10;
  for I:= 0 to High(Data) do with Data[I] do
    Hlaseni:= Hlaseni + Popis + ': ' + Text + #13#10;
  Delete(Hlaseni,Length(Hlaseni),1);
  for I:= 1 to Length(Hlaseni)do  if Hlaseni[I]=' ' then Hlaseni[I]:= '+';
  if Proxy then begin
    ProxyPort:= Copy(ProxyServer,Pos(':',ProxyServer)+1,255);
    Delete(ProxyServer,Pos(':',ProxyServer),255);
    TCPClient1.RemoteHost:= ProxyServer;
    TCPClient1.RemotePort:= ProxyPort;
    Host:= Mailer;
    HostHTTP:= 'http://'+Host;
  end else begin
    TCPClient1.RemoteHost:= Mailer;
    TCPClient1.RemotePort:= '80';
    Host:= '';
  end;
  with TcpClient1 do begin
    Connect;
    if Connected then begin
      SendLn('POST '+HostHTTP+'/cgi-bin/pl/mailer.new.cgi HTTP/1.0');
      //OProgramu.Memo2.Lines.Add('POST '+Host+'/cgi-bin/pl/mailer.new.cgi HTTP/1.0');
      SendLn('Accept: text/html');
      SendLn('Content-Type: text/plain; charset="iso-8859-2"');
      SendLn('Content-length: '+IntToStr(Length(Hlaseni)));
      if Proxy then SendLn('Host: '+Host);
      SendLn('');
      SendLn(Hlaseni);
(*      repeat
        Pocet:= ReceiveBuf(Buf,SizeOf(Buf),0);
        for I:= 0 to Pocet-1 do Radek:= Radek + Buf[I];
        while Pos(#10,Radek)>0 do begin
          OProgramu.Memo2.Lines.Add(Copy(Radek,1,Pos(#10,Radek)-1));
          Delete(Radek,1,Pos(#10,Radek));
        end;
      until Pocet=0;
*)      Close;
    end else ShowMessage('Nepodailo se pipojit k serveru');
  end;
  SetLength(Data,0);
end;

procedure TOsetreniVyjimek.Button2Click(Sender: TObject);
begin
  if Height=Vyska then Height:= Vyska+122 else Height:= Vyska;
end;

procedure TOsetreniVyjimek.FormShow(Sender: TObject);
var
  I: Integer;
begin
  Vyska:= Height;
  Memo1.Clear;
  for I:= 0 to High(Data) do with Data[I] do Memo1.Lines.Add(Popis+': '+Text);
  Edit1.Text:= '';
end;

procedure TOsetreniVyjimek.Button1Click(Sender: TObject);
begin
  Close;
end;

{ TOdeslani }

procedure TOdeslani.Execute;
begin
  Bezi:= True;
  OsetreniVyjimek.Odeslat;
  Bezi:= False;
end;

procedure TOsetreniVyjimek.FormCreate(Sender: TObject);
begin
  Odeslani:= TOdeslani.Create(True);
  NazevAplikace:= Application.Title;
//  Application.OnException:= Obsluha;
end;

procedure TOsetreniVyjimek.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Height:= Vyska;
end;

end.
