unit UOptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, DSPack, DSUtil, DirectShow9, StrUtils;

type
  TOptions = class(TForm)
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    Button2: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label4: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure StartVideo;
  end;

var
  Options: TOptions;
  SysDev: TSysDevEnum;

implementation

uses UMainWindow, UPreview, UProgress;

{$R *.dfm}

procedure TOptions.Button3Click(Sender: TObject);
begin
  if OpenDialog1.Execute then Memo1.Lines.Strings[0]:= OpenDialog1.FileName;
end;

procedure TOptions.FormShow(Sender: TObject);
var
  I: Integer;
begin
  RadioButton1.Checked:= MainWindow.ZdrojTyp;
  RadioButton2.Checked:= not MainWindow.ZdrojTyp;
  ComboBox1.Items.Clear;
  //SysDev:= TSysDevEnum.Create(CLSID_VideoInputDeviceCategory);
  //if SysDev.CountFilters > 0 then
  for I := 0 to SysDev.CountFilters - 1 do
  begin
    ComboBox1.Items.Add(SysDev.Filters[I].FriendlyName);
  end;
  if SysDev.CountFilters>0 then begin
    ComboBox1.ItemIndex:= MainWindow.ZdrojVidea;
    ComboBox1Change(Self);
  end;
end;

procedure TOptions.ComboBox1Change(Sender: TObject);
var
  EnumMT : TEnumMediaType;
  PinList: TPinList;
  I: Integer;
begin
  MainWindow.StopVideo;
  EnumMT:= TEnumMediaType.Create;
  with MainWindow do begin
//    FilterGraph1.Active := False;
    Filter1.BaseFilter.Moniker := SysDev.GetMoniker(ComboBox1.ItemIndex);
    Filter1.FilterGraph := FilterGraph1;
    FilterGraph1.Active := True;
  end;

  PinList := TPinList.Create(MainWindow.Filter1 as IBaseFilter);
  EnumMT.Assign(PinList.First);
  for I := 0 to EnumMT.Count - 1 do
    ComboBox2.Items.Add(EnumMT.MediaDescription[I]);
  if EnumMT.Count>0 then begin
    ComboBox2.ItemIndex:= MainWindow.ZdrojRezim;
  end;
  EnumMT.Free;
end;

procedure TOptions.Button1Click(Sender: TObject);
begin
  if ComboBox1.ItemIndex>0 then MainWindow.ZdrojVidea:= ComboBox1.ItemIndex;
  if ComboBox2.ItemIndex>0 then MainWindow.ZdrojRezim:= ComboBox2.ItemIndex;
  with MainWindow do begin
    ZdrojTyp:= RadioButton1.Checked;
    StartVideo;
  end;
  Close;
end;

procedure TOptions.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TOptions.StartVideo;
var
  PinList: TPinList;
  EnumMT: TEnumMediaType;
  Prvni: string;
begin
  Progress.Show;
  Application.ProcessMessages;
  MainWindow.Detekce.InitPinValues;
  with MainWindow do begin
    FilterGraph1.Stop;
    FilterGraph1.ClearGraph;
    FilterGraph1.Active := False;
    if ZdrojTyp then begin
      // Spustit video z kamery
      //FilterGraph1.ClearGraph;
      Filter1.BaseFilter.Moniker := SysDev.GetMoniker(0);//VyberZdroje.ComboBox1.ItemIndex);
      EnumMT:= TEnumMediaType.Create;
      FilterGraph1.Active := True;
      PinList := TPinList.Create(Filter1 as IBaseFilter);
      EnumMT.Assign(PinList.First);
      with (PinList.First as IAMStreamConfig) do
        SetFormat(EnumMT.Items[ZdrojRezim].AMMediaType^);
      PinList.Free;
      //FilterGraph1.Active := True;
      with FilterGraph1 as ICaptureGraphBuilder2 do
        RenderStream(@PIN_CATEGORY_PREVIEW, nil, Filter1 as IBaseFilter, SampleGrabber1 as IBaseFilter, VideoWindow1 as IbaseFilter);
      EnumMT.Free;
    end else begin
      // Spustit video ze souboru
      //NastavVelikostSnimku(352,288);
      FilterGraph1.Active := true;
      if FileExists(Memo1.Lines.Strings[0]) then FilterGraph1.RenderFile(Memo1.Lines.Strings[0]) else
      ShowMessage('Soubor '+Memo1.Lines.Strings[0]+' nenalezen!');
    end;

    // Zjitn rozmr videa
    EnumMT:= TEnumMediaType.Create;
    EnumMT.Assign(SampleGrabber1.OutPutPin);
  //  EnumMT.Items.
  //  ListBox1.Items.BeginUpdate;
  //  ListBox1.Items.Clear;
    Prvni:= EnumMT.MediaDescription[0];
    Prvni:= ReverseString(Copy(Prvni,1,Pos(',',Prvni)-1));
    Prvni:= ReverseString(Copy(Prvni,1,Pos(' ',Prvni)-1));
    ChangeVideoResolution(StrToInt(Copy(Prvni,1,Pos('X',Prvni)-1)),
    StrToInt(Copy(Prvni,Pos('X',Prvni)+1,10)));
    //Label2.Caption:= IntToStr(SnimekX)+'x'+IntToStr(SnimekY);
    //for I := 0 to EnumMT.Count - 1 do
    //  ListBox1.Items.Add(EnumMT.MediaDescription[I]);
    //ListBox1.Items.EndUpdate;
    EnumMT.Free;
    CheckBox1Click(Self);
    FilterGraph1.Play;
    VideoEnabled:= True;
  end;
  Progress.Close;
end;

procedure TOptions.FormCreate(Sender: TObject);
begin
  SysDev:= TSysDevEnum.Create(CLSID_VideoInputDeviceCategory);
  Memo1.Lines.Strings[0]:= MainWindow.Soubor;
end;

end.
