unit UTransform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UAproxim, ExtCtrls, ComCtrls, StdCtrls;

const
  Table: array[0..8,0..3] of Integer =
  ((34,14,211,108),(32,359,214,96),(36,746,226,60),(539,753,204,63),
  (1001,745,183,63),(1005,344,172,100),(1011,28,174,109),(491,13,191,110),(503,328,188,93));

type
  TTransform = class(TForm)
    PaintBox2: TPaintBox;
    ListView1: TListView;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
  end;

var
  Transform: TTransform;

implementation

uses UMainWindow;

{$R *.dfm}

procedure TTransform.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  with MainWindow.Detekce.Aproxim do begin
    Reset;
    for I:= 0 to High(Table) do begin
      Pridej(Table[I,2],Table[I,3],Table[I,0],Table[I,1]);
    end;
    Aproximuj;
  end;
end;

procedure TTransform.FormPaint(Sender: TObject);
const
  Pol = 2;
  Nasobek = 3;
var
  I: Integer;
  Bod, Bod2: TPoint;
  X, Y: Integer;
  MaxX, MinX, MaxY, MinY: Integer;
  MaxX1, MinX1, MaxY1, MinY1: Integer;
  Item: TListItem;

function GetY(Y: Integer): Integer;
begin
  Result:= Round(Y/20*(MaxY-MinY)+MinY*1.07)
end;

function GetX(X: Integer): Integer;
begin
  Result:= Round(X/20*(MaxX-MinX)+MinX*1.07)
end;

function SetX(X:Integer): Integer;
begin
  Result:= Round(X/Screen.Width*Transform.PaintBox2.Width);
end;

function SetY(Y:Integer): Integer;
begin
  Result:= Round(Y/Screen.Height*Transform.PaintBox2.Height);
end;

begin
  with ListView1, MainWindow.Detekce.Aproxim do begin
    Items.BeginUpdate;
    Items.Clear;
    MinX:= High(Integer);
    MinY:= High(Integer);
    MaxX:= 0;
    MaxY:= 0;
    MinX1:= High(Integer);
    MinY1:= High(Integer);
    MaxX1:= 0;
    MaxY1:= 0;
    for I:= 0 to Pocet-1 do begin
      Item:= Items.Add;
      Item.Caption:= FloatToStr(Data[I].X0);
      with Item.SubItems do begin
        Add(FloatToStr(Data[I].Y0));
        Add(FloatToStr(Data[I].X1));
        Add(FloatToStr(Data[I].Y1));
        if Data[I].X0>MaxX then MaxX:= Round(Data[I].X0);
        if Data[I].Y0>MaxY then MaxY:= Round(Data[I].Y0);
        if Data[I].X0<MinX then MinX:= Round(Data[I].X0);
        if Data[I].Y0<MinY then MinY:= Round(Data[I].Y0);
        if Data[I].X1>MaxX1 then MaxX1:= Round(Data[I].X1);
        if Data[I].Y1>MaxY1 then MaxY1:= Round(Data[I].Y1);
        if Data[I].X1<MinX1 then MinX1:= Round(Data[I].X1);
        if Data[I].Y1<MinY1 then MinY1:= Round(Data[I].Y1);
      end;
    end;
    Items.EndUpdate;
  end;
  if MinX> 1024 then begin
    MinX:= 0;
    MaxX:= 1;
  end;
  if MinY> 768 then begin
    MinY:= 0;
    MaxY:= 1;
  end;
  if MinX1> 1024 then begin
    MinX1:= 0;
    MaxX1:= 1;
  end;
  if MinY1> 768 then begin
    MinY1:= 0;
    MaxY1:= 1;
  end;
//  if MainWindow.Detekce.Aproxim.Pocet>1 then
  Label1.Caption:= FloatToStr((MaxX1-MinX1)/(MaxX-MinX+0.001))+' x '+FloatToStr((MaxY1-MinY1)/(MaxY-MinY+0.001));

  with PaintBox2,MainWindow.Detekce.Aproxim do begin
    Canvas.Brush.Color:= clWhite;
    Canvas.FillRect(Rect(0,0,Width,Height));
    Canvas.Pen.Color:= clBlue;
    for Y:= 0 to 9 do begin
      Canvas.MoveTo(GetX(0),GetY(Y));
      for X:= 0 to 9 do begin
        Bod:= Point(GetX(X),GetY(Y));
        Canvas.LineTo(Bod.X,Bod.Y);
      end;
    end;
    for X:= 0 to 9 do begin
      Canvas.MoveTo(GetX(X),GetY(0));
      for Y:= 0 to 9 do begin
        Bod:= Point(GetX(X),GetY(Y));
        Canvas.LineTo(Bod.X,Bod.Y);
      end;
    end;
    Canvas.Pen.Color:= clRed;
    for Y:= 0 to 9 do begin
      Bod2:= Transform(Point(GetX(0),GetY(Y)));
      Canvas.MoveTo(SetX(Bod2.X),SetY(Bod2.Y));
      for X:= 0 to 9 do begin
        Bod:= Point(GetX(X),GetY(Y));
        Bod2:= Transform(Bod);
        Canvas.LineTo(SetX(Bod2.X),SetY(Bod2.Y));
      end;
    end;
    for X:= 0 to 9 do begin
      Bod2:= Transform(Point(GetX(X),GetY(0)));
      Canvas.MoveTo(SetX(Bod2.X),SetY(Bod2.Y));
      for Y:= 0 to 9 do begin
        Bod:= Point(GetX(X),GetY(Y));
        Bod2:= Transform(Bod);
        Canvas.LineTo(SetX(Bod2.X),SetY(Bod2.Y));
      end;
    end;
  end;
end;

end.
